{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#bqsr.cwl/advanced_options"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--after"
                    },
                    "id": "#bqsr.cwl/after"
                },
                {
                    "type": "string",
                    "default": "QualCal",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#bqsr.cwl/algo"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--before"
                    },
                    "id": "#bqsr.cwl/before"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#bqsr.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--interval",
                        "position": 10
                    },
                    "id": "#bqsr.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-k"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#bqsr.cwl/known_sites"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--merge"
                    },
                    "id": "#bqsr.cwl/merge"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--qcal"
                    },
                    "id": "#bqsr.cwl/other_qcal"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#bqsr.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 180
                    },
                    "id": "#bqsr.cwl/part_output"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 110,
                        "prefix": "--plot"
                    },
                    "id": "#bqsr.cwl/plot"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-q"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "id": "#bqsr.cwl/qcal"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#bqsr.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#bqsr.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#bqsr.cwl/threads"
                }
            ],
            "stderr": "bqsr.log",
            "id": "#bqsr.cwl",
            "outputs": [
                {
                    "type": "File",
                    "id": "#bqsr.cwl/log",
                    "outputBinding": {
                        "glob": "bqsr.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "id": "#bqsr.cwl/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "plot"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#plot.cwl/fun"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "gc="
                    },
                    "id": "#plot.cwl/gc"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 20
                    },
                    "id": "#plot.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "isize="
                    },
                    "id": "#plot.cwl/isize"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "min_fp_rate="
                    },
                    "id": "#plot.cwl/min_fp_rate"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "mq="
                    },
                    "id": "#plot.cwl/mq"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-o"
                    },
                    "id": "#plot.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "point_size="
                    },
                    "id": "#plot.cwl/point_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "qd="
                    },
                    "id": "#plot.cwl/qd"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "target_titv="
                    },
                    "id": "#plot.cwl/target_titv"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 50,
                        "separate": false,
                        "prefix": "tranches_file="
                    },
                    "id": "#plot.cwl/tranches_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#plot.cwl/log",
                    "outputBinding": {
                        "glob": "plot.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "id": "#plot.cwl/output"
                }
            ],
            "stderr": "plot.log",
            "id": "#plot.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#bqsr-distr.cwl/advanced_options"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#bqsr-distr.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "id": "#bqsr-distr.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#bqsr-distr.cwl/known_sites"
                },
                {
                    "type": "string",
                    "id": "#bqsr-distr.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "id": "#bqsr-distr.cwl/qcal"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#bqsr-distr.cwl/reference"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#bqsr-distr.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#bqsr-distr.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#bqsr-distr.cwl/merge/output",
                    "id": "#bqsr-distr.cwl/output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "default": ".table",
                            "id": "#bqsr-distr.cwl/bqsr/_ext"
                        },
                        {
                            "source": "#bqsr-distr.cwl/output_file",
                            "id": "#bqsr-distr.cwl/bqsr/_output"
                        },
                        {
                            "source": "#bqsr-distr.cwl/shard",
                            "id": "#bqsr-distr.cwl/bqsr/_shard"
                        },
                        {
                            "source": "#bqsr-distr.cwl/advanced_options",
                            "id": "#bqsr-distr.cwl/bqsr/advanced_options"
                        },
                        {
                            "source": "#bqsr-distr.cwl/input_bam",
                            "id": "#bqsr-distr.cwl/bqsr/input_bam"
                        },
                        {
                            "source": "#bqsr-distr.cwl/interval",
                            "id": "#bqsr-distr.cwl/bqsr/interval"
                        },
                        {
                            "source": "#bqsr-distr.cwl/known_sites",
                            "id": "#bqsr-distr.cwl/bqsr/known_sites"
                        },
                        {
                            "source": "#bqsr-distr.cwl/shard",
                            "linkMerge": "merge_flattened",
                            "valueFrom": "${\n  var len = inputs._shard.length;\n  var i = 0;\n  for (; i < len; ++i) {\n     if (self == inputs._shard[i])\n       break;\n  }\n  return inputs._output + \"_part_\" + i + inputs._ext;\n}\n",
                            "id": "#bqsr-distr.cwl/bqsr/output_file"
                        },
                        {
                            "source": "#bqsr-distr.cwl/qcal",
                            "id": "#bqsr-distr.cwl/bqsr/qcal"
                        },
                        {
                            "source": "#bqsr-distr.cwl/reference",
                            "id": "#bqsr-distr.cwl/bqsr/reference"
                        },
                        {
                            "source": "#bqsr-distr.cwl/shard",
                            "id": "#bqsr-distr.cwl/bqsr/shard"
                        },
                        {
                            "source": "#bqsr-distr.cwl/threads",
                            "id": "#bqsr-distr.cwl/bqsr/threads"
                        }
                    ],
                    "out": [
                        "#bqsr-distr.cwl/bqsr/output"
                    ],
                    "scatter": [
                        "#bqsr-distr.cwl/bqsr/shard",
                        "#bqsr-distr.cwl/bqsr/output_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": "#bqsr.cwl",
                    "id": "#bqsr-distr.cwl/bqsr"
                },
                {
                    "in": [
                        {
                            "valueFrom": "${ return true; }",
                            "id": "#bqsr-distr.cwl/merge/merge"
                        },
                        {
                            "source": "#bqsr-distr.cwl/output_file",
                            "id": "#bqsr-distr.cwl/merge/output_file"
                        },
                        {
                            "source": "#bqsr-distr.cwl/bqsr/output",
                            "id": "#bqsr-distr.cwl/merge/part_output"
                        },
                        {
                            "source": "#bqsr-distr.cwl/threads",
                            "id": "#bqsr-distr.cwl/merge/threads"
                        }
                    ],
                    "out": [
                        "#bqsr-distr.cwl/merge/output"
                    ],
                    "run": "#bqsr.cwl",
                    "id": "#bqsr-distr.cwl/merge"
                }
            ],
            "id": "#bqsr-distr.cwl"
        },
        {
            "class": "Workflow",
            "doc": "Run BQSR pre+post+plot flow with distribution",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#main/advanced_options/bqsr",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                },
                                {
                                    "name": "#main/advanced_options/bqsr_post",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    "id": "#main/advanced_options"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#main/input_bam"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/known_sites"
                },
                {
                    "type": "string",
                    "id": "#main/output_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/plot_output_csv_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/plot_output_file"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/bqsr_plot/output",
                    "id": "#main/plot_csv_output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/plot/output",
                    "id": "#main/plot_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bqsr/output",
                    "id": "#main/qcal_output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/advanced_options",
                            "valueFrom": "${ return self ? self.bqsr : []; }\n",
                            "id": "#main/bqsr/advanced_options"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/bqsr/input_bam"
                        },
                        {
                            "source": "#main/known_sites",
                            "id": "#main/bqsr/known_sites"
                        },
                        {
                            "source": "#main/output_file",
                            "id": "#main/bqsr/output_file"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/bqsr/reference"
                        },
                        {
                            "source": "#main/shard",
                            "id": "#main/bqsr/shard"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/bqsr/threads"
                        }
                    ],
                    "out": [
                        "#main/bqsr/output"
                    ],
                    "run": "#bqsr-distr.cwl",
                    "id": "#main/bqsr"
                },
                {
                    "in": [
                        {
                            "source": "#main/bqsr_post/output",
                            "id": "#main/bqsr_plot/after"
                        },
                        {
                            "source": "#main/bqsr/output",
                            "id": "#main/bqsr_plot/before"
                        },
                        {
                            "source": [
                                "#main/output_file",
                                "#main/plot_output_csv_file"
                            ],
                            "valueFrom": "${ if(self[1] != null) return self[1]; else return self[0] + \".csv\"; }",
                            "id": "#main/bqsr_plot/output_file"
                        },
                        {
                            "valueFrom": "${ return true; }",
                            "id": "#main/bqsr_plot/plot"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/bqsr_plot/threads"
                        }
                    ],
                    "out": [
                        "#main/bqsr_plot/output"
                    ],
                    "run": "#bqsr.cwl",
                    "id": "#main/bqsr_plot"
                },
                {
                    "in": [
                        {
                            "source": "#main/advanced_options",
                            "valueFrom": "${ return self ? self.bqsr_post : []; }\n",
                            "id": "#main/bqsr_post/advanced_options"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/bqsr_post/input_bam"
                        },
                        {
                            "source": "#main/output_file",
                            "valueFrom": "$(self).post",
                            "id": "#main/bqsr_post/output_file"
                        },
                        {
                            "source": "#main/bqsr/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/bqsr_post/qcal"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/bqsr_post/reference"
                        },
                        {
                            "source": "#main/shard",
                            "id": "#main/bqsr_post/shard"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/bqsr_post/threads"
                        }
                    ],
                    "out": [
                        "#main/bqsr_post/output"
                    ],
                    "run": "#bqsr-distr.cwl",
                    "id": "#main/bqsr_post"
                },
                {
                    "in": [
                        {
                            "valueFrom": "${ return \"bqsr\"; }",
                            "id": "#main/plot/fun"
                        },
                        {
                            "source": "#main/bqsr_plot/output",
                            "id": "#main/plot/input"
                        },
                        {
                            "source": [
                                "#main/output_file",
                                "#main/plot_output_file"
                            ],
                            "valueFrom": "${ if(self[1] != null) return self[1]; else return self[0] + \".pdf\"; }",
                            "id": "#main/plot/output_file"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/plot/threads"
                        }
                    ],
                    "out": [
                        "#main/plot/output"
                    ],
                    "run": "#plot.cwl",
                    "id": "#main/plot"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
